#include "psram.h"
#include "delay.h"
#include "spi.h"

//u8 SPI_ReadWrite(u8 dat) {
//    u8 i,rst = 0;
//    for(i=0; i<8; i++) {
//        PSRAM_CLK = 0;
//        PSRAM_MOSI = (bit)(dat & 0x80);              
//        dat <<= 1;
//        PSRAM_CLK = 1;
//        rst <<= 1;
//        rst |= PSRAM_MISO;
//        
//    }
//    return rst;
//}

void PSRAM_PowerOn_Init(void){
//    P3M0 = 0x94; P3M1 = 0x08;
//    P3M0 = 0xe0; P3M1 = 0x00; //P3.7,P3.6,P3.5λPSRAM
//    P1M0 = 0x01; P1M1 = 0x02; //P1.0,P1.1

    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();    
    POWER_PIN = 1;
    PSRAM_CS  = 1;
    PSRAM_CLK = 0;
    PSRAM_MISO = 0; //IO0
    PSRAM_MOSI = 0; //IO1
    PSRAM_HOLD = 0; //IO3
    PSRAM_WP  = 0;  //IO2
    Delay_ms(1);
    PSRAM_CS = 1;
    PSRAM_HOLD = 1; // HOLD
    PSRAM_WP = 1;   // д
    PSRAM_MISO = 1; //IO0
    PSRAM_MOSI = 1; //IO1
    PSRAM_CLK = 1;
}

// PSRAMʼ
void PSRAM_Init(void)
{
    PSRAM_PowerOn_Init();
    SPI_Init();
    // ͸λ
    PSRAM_CS = 0;
    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();
    SPI_ReadWrite(PSRAM_RESET_EN);
    PSRAM_CS = 1;
    
    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();
    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_(); 
    
    PSRAM_CS = 0;
    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();

    SPI_ReadWrite(PSRAM_RESET);

    PSRAM_CS = 1;
    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();
    // ʱȴPSRAM׼
    Delay_ms(1);
}

// PSRAMȡ
void PSRAM_Read(unsigned long addr, unsigned char *buf, unsigned int len)
{
    unsigned int i;
    PSRAM_CS = 0;
    _nop_();_nop_();_nop_();_nop_();
    SPI_ReadWrite(PSRAM_READ);

    // 24λַ(PSRAM64H8Mb x8, Ҫ24λַ)
    SPI_ReadWrite((addr >> 16) & 0xFF);
    SPI_ReadWrite((addr >> 8) & 0xFF);
    SPI_ReadWrite(addr & 0xFF);
   
    for(i=0; i<len; i++)
    {
        buf[i] = SPI_ReadWrite(0xFF); // ȡ
    }
    PSRAM_CS = 1;
    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();
}

// PSRAMд
void PSRAM_Write(unsigned long addr, unsigned char *buf, unsigned int len)
{
    unsigned int i;
    
    PSRAM_CS = 0;
    _nop_();_nop_();_nop_();_nop_();
    SPI_ReadWrite(PSRAM_WRITE);
    // 24λַ
    SPI_ReadWrite((addr >> 16) & 0xFF);
    SPI_ReadWrite((addr >> 8) & 0xFF);
    SPI_ReadWrite(addr & 0xFF);   
    for(i=0; i<len; i++)
    {
        SPI_ReadWrite(buf[i]); // д
    }
    PSRAM_CS = 1;
}

// ȡPSRAM ID
void PSRAM_ReadID(unsigned char *id,unsigned char len)
{ 
    unsigned char i;
    PSRAM_CS = 0;
    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();
        
    SPI_ReadWrite(PSRAM_READ_ID);
//addr start
    SPI_ReadWrite(0x00);
    SPI_ReadWrite(0x00);
    SPI_ReadWrite(0x00);
//addr over
        
    for(i = 0;i <len ;i++)
        id[i] = SPI_ReadWrite(0xFF);

    PSRAM_CS = 1;
}