#ifndef PSRAM_H
#define PSRAM_H

#include <stc8g.h>
// PSRAMָ
#define PSRAM_READ      0x03
#define PSRAM_WRITE     0x02
#define PSRAM_READ_ID   0x9F
#define PSRAM_ENTER_QPI 0x35
#define PSRAM_EXIT_QPI  0xF5
#define PSRAM_RESET_EN  0x66
#define PSRAM_RESET     0x99

//PSRAMоƬز½
// PSRAM
//sbit PSRAM_CS  = P2^6;
//sbit PSRAM_CLK = P2^5;
//sbit PSRAM_MISO = P2^7; //IO1
//sbit PSRAM_MISO = P2^4; //IO1
//sbit PSRAM_MOSI = P2^3; //IO0

#define PSRAM_CS  CS
#define PSRAM_CLK CLK
#define PSRAM_MISO MISO
#define PSRAM_MOSI MOSI

sbit PSRAM_HOLD = P1^7; //IO3
sbit PSRAM_WP  = P1^6;  //IO2

sbit POWER_PIN = P3^7;  //psramоƬVCC


void PSRAM_PowerOn_Init(void);
void PSRAM_Init(void);
void PSRAM_Read(unsigned long addr, unsigned char *buf, unsigned int len);
void PSRAM_Write(unsigned long addr, unsigned char *buf, unsigned int len);
void PSRAM_ReadID(char *id,unsigned char len);
#endif