#include "spi.h"
#if defined(HARDWARE_SPI)

    #define SPIF 0x80
    #define WCOL 0x40
    #define SSIG 0x80
    #define SPEN 0x40
    #define DORD 0x20
    #define MSTR 0x10

    void SPI_Init(void){       
        P_SW1 |= 0x0c;		//SPI: SS(P3.5), MOSI(P3.4), MISO(P3.3), SCLK(P3.2)
        SPCTL = 0x9C;   //SSIG=1,SPEN=0,DORD=0,MSTR=1,CPOL=0,CPHA=0,SPR[1:0]=00b
        SPCTL |= SPI_MODE<<2;
        SPSTAT = 0xC0;  //SPIFWCOLд1
        SPCTL |= SPEN;  //ʹӲSPI
    }
    
    u8 SPI_ReadWrite(u8 dat){
        SPDAT = dat;
        while(!(SPSTAT & SPIF));
        SPSTAT = 0xC0;
        return SPDAT;
    }

#else
    void SPI_Init(void){
        CS = 1;
        MOSI = 1;
        MISO = 1;
        CLK = S_CPOL;
    }

    u8 SPI_ReadWrite(u8 dat){
        u8 rst = 0;
        u8 i;
        for(i = 0; i < 8; i++){
    #if (S_CPHA)        //ǰز
        {
            CLK = !S_CPOL;
            MOSI = (bit)(dat & 0x80);
            dat <<= 1;
            CLK = S_CPOL;
            rst <<= 1;
            rst |= MISO;        
        }
    #else            //ǰز
        {
            MOSI = (bit)(dat & 0x80);
            dat <<= 1;
            CLK = !S_CPOL;
            rst <<= 1;
            rst |= MISO;
            CLK = S_CPOL;
        }
    #endif    
        }
        return rst;
    }
#endif