#ifndef SPI_H
#define SPI_H
#include "stc8g.h"
#define SPI_MODE0 0
#define SPI_MODE1 1
#define SPI_MODE2 2
#define SPI_MODE3 3

#define SPI_MODE SPI_MODE3
#if (SPI_MODE == SPI_MODE0)
    #define S_CPOL 0
    #define S_CPHA 0
#elif  (SPI_MODE == SPI_MODE1)
    #define S_CPOL 0
    #define S_CPHA 1
#elif  (SPI_MODE == SPI_MODE2)
    #define S_CPOL 1
    #define S_CPHA 0  
#elif  (SPI_MODE == SPI_MODE3)
    #define S_CPOL 1
    #define S_CPHA 1    
#endif

//// SPI
//sbit CS  = P2^6;
//sbit CLK = P2^5;
//sbit MISO = P2^7; //IO1
////sbit PSRAM_MISO = P2^4; //IO1
//sbit MOSI = P2^3; //IO0

// SPI
sbit CS  = P1^0;
sbit CLK = P3^5;
sbit MISO = P1^1; //IO1
sbit MOSI = P3^6; //IO0
//SPI: SS(P3.5), MOSI(P3.4), MISO(P3.3), SCLK(P3.2)

//sbit CS  = P1^0;
//sbit CLK = P3^2;
//sbit MISO = P3^3; //IO1
//sbit MOSI = P3^4; //IO0

void SPI_Init(void);
u8 SPI_ReadWrite(u8 dat);
#endif