#include "uart.h"
bit serial_busy;
char wptr;
char rptr;
char buffer[16];

void Uart1_Isr(void) interrupt 4
{
	if (TI)				//检测串口1发送中断
	{
		TI = 0;			//清除串口1发送中断请求位
        serial_busy = 0;
	}
	if (RI)				//检测串口1接收中断
	{
		RI = 0;			//清除串口1接收中断请求位
        buffer[wptr++] = SBUF;
        wptr &= 0x0F;
	}
}

void Uart1_Init(void)	//115200bps@24.000MHz
{
	SCON = 0x50;		//8位数据,可变波特率
	AUXR |= 0x01;		//串口1选择定时器2为波特率发生器
	AUXR |= 0x04;		//定时器时钟1T模式
	T2L = 0xCC;			//设置定时初始值
	T2H = 0xFF;			//设置定时初始值
	AUXR |= 0x10;		//定时器2开始计时
	ES = 1;				//使能串口1中断
}

void UartSend(char dat)
{
    while (serial_busy);
    serial_busy = 1;
    SBUF = dat;
}

//void UartSendStr(char *p)
//{
//    while (*p)
//    {
//        UartSend(*p++);
//    }
//}

char putchar(char c){
    UartSend(c);
    return c;
}

void PrintHex2Str(unsigned char dat){
    unsigned char i,j;
    i = (dat & 0xF0)>>4;
    j = dat & 0x0F;
    if(i >= 0 && i <=9)
        i += '0';
    else if(i >= 10 && i <= 15)
        i = i - 10 + 'A';
    if(j >= 0 && j <=9)
        j += '0';
    else if(j >= 10 && j <= 15)
        j = j - 10 + 'A';
    UartSend(i);
    UartSend(j);
    UartSend(' ');
}
void PrintLong2Str(long addr){
    unsigned char dat,i,j;
    dat = (addr >> 16) & 0xFF;
    i = (dat & 0xF0)>>4;
    j = dat & 0x0F;
    if(i >= 0 && i <=9)
        i += '0';
    else if(i >= 10 && i <= 15)
        i = i - 10 + 'A';
    if(j >= 0 && j <=9)
        j += '0';
    else if(j >= 10 && j <= 15)
        j = j - 10 + 'A';
    UartSend(i);
    UartSend(j);
    
    dat = (addr >> 8) & 0xFF;
    i = (dat & 0xF0)>>4;
    j = dat & 0x0F;
    if(i >= 0 && i <=9)
        i += '0';
    else if(i >= 10 && i <= 15)
        i = i - 10 + 'A';
    if(j >= 0 && j <=9)
        j += '0';
    else if(j >= 10 && j <= 15)
        j = j - 10 + 'A';
    UartSend(i);
    UartSend(j);
    
    dat = addr & 0xFF;
    i = (dat & 0xF0)>>4;
    j = dat & 0x0F;
    if(i >= 0 && i <=9)
        i += '0';
    else if(i >= 10 && i <= 15)
        i = i - 10 + 'A';
    if(j >= 0 && j <=9)
        j += '0';
    else if(j >= 10 && j <= 15)
        j = j - 10 + 'A';
    UartSend(i);
    UartSend(j);
    UartSend(' ');UartSend(' ');UartSend(' ');UartSend(' ');
}